#include <bits/stdc++.h>

using namespace std;

vector<long int> osztoimeg(long int n)
{
    vector<long int> osztoi;
    int meddig=sqrt(n);

    for(long int i=1;i<=meddig;i++)
    {
        if(n%i==0)
        {
            osztoi.push_back(i);
            if(n/i != i)
              osztoi.push_back(n/i);
        }
    }


    return osztoi;
}




int main()
{

    long int n, k;
    cin>>n>>k;

    vector<long int> osztok(k);
    for(long int i=0;i<k;i++)
    {
        cin>>osztok.at(i);
    }

    long int szam;
    long int ertek;
    for(long int i=0;i<k;i++)
    {
        szam=osztok.at(i);

        vector<long int> osztoi=osztoimeg(szam);

        ertek=osztoi.at(0);

        for(long int j=1;j<osztoi.size();j++)
        {
             ertek=ertek^osztoi.at(j);

        }
        cout<<ertek<<" ";
    }






    return 0;
}